<template>
    <v-container>
        <h1>{{ $t('message') }}</h1>

        <v-row>
            <v-col :key="`${sale.title}`" cols="12" md="4" v-for="sale in sales">
                <SalesGraph :sale="sale"/>
            </v-col>
        </v-row>

        <v-row>
            <v-col
                    :key="`${statistic.title}`"
                    cols="12"
                    lg="3"
                    md="6"
                    v-for="statistic in statistics"
            >
                <StatisticCard :statistic="statistic"/>
            </v-col>
        </v-row>

        <v-row id="below-the-fold" v-intersect="showMoreContent">
            <v-col cols="12" md="8">
                <EmployeesTable :employees="employees" @select-employee="setEmployee"/>
            </v-col>
            <v-col cols="12" md="4">
                <EventTimeline :timeline="timeline"/>
            </v-col>
        </v-row>

        <v-row id="more-content" v-if="loadNewContent">
            <v-col>
                <v-skeleton-loader class="mx-auto" ref="skeleton" type="table"></v-skeleton-loader>
            </v-col>
        </v-row>

        <v-snackbar :left="$vuetify.breakpoint.lgAndUp" v-model="snackbar">
            You have selected {{ selectedEmployee.name }},
            {{ selectedEmployee.title }}
            <v-btn @click="snackbar = false" color="pink" text>
                Close
            </v-btn>
        </v-snackbar>
    </v-container>
</template>

<script>
    import EmployeesTable from '../components/EmployeesTable'
    import EventTimeline from '../components/EventTimeline'
    import SalesGraph from '../components/SalesGraph'
    import StatisticCard from '../components/StatisticCard'

    import employeesData from '../data/employees.json'
    import timelineData from '../data/timeline.json'
    import salesData from '../data/sales.json'
    import statisticsData from '../data/statistics.json'

    export default {
        name: 'DashboardPage',
        components: {
            EmployeesTable,
            EventTimeline,
            SalesGraph,
            StatisticCard
        },
        data() {
            return {
                employees: employeesData,
                sales: salesData,
                selectedEmployee: {
                    name: '',
                    title: ''
                },
                snackbar: false,
                statistics: statisticsData,
                timeline: timelineData,
                loadNewContent: false
            }
        },
        methods: {
            setEmployee(event) {
                this.snackbar = true
                this.selectedEmployee.name = event.name
                this.selectedEmployee.title = event.title
            },
            showMoreContent(entries) {
                this.loadNewContent = entries[0].isIntersecting;
            }
        }
    }
</script>